import {
  AccessScopeAnalysisFinding,
  AddressAttribute,
  AddressTransfer,
  AllowedImagesSettingsEnabledState,
  AutoPlacement,
  CurrencyCodeValues,
  DeviceTrustProviderType,
  HostMaintenance,
  HostRecovery,
  IpamPoolAllocation,
  SubnetAssociation,
  Tag,
  TagSpecification,
  TargetConfigurationRequest,
  TransitGatewayAssociationState,
  TransitGatewayAttachmentResourceType,
  TransitGatewayPolicyTableAssociation,
  UnsuccessfulItem,
  UserTrustProviderType,
} from "./models_0";
import {
  _InstanceType,
  AttributeValue,
  CapacityReservationPreference,
  CapacityReservationState,
  CapacityReservationTarget,
  ClientConnectOptions,
  ClientLoginBannerOptions,
  ConnectionLogOptions,
  DiskImageFormat,
  EndDateType,
  FleetExcessCapacityTerminationPolicy,
  FleetLaunchTemplateConfigRequest,
  InstanceMatchCriteria,
  InstanceRequirementsRequest,
  IpamResourceTag,
  Placement,
  PlatformValues,
  RequestIpamResourceTag,
  ResponseLaunchTemplateData,
  SelfServicePortal,
  ShutdownBehavior,
  TargetCapacitySpecificationRequest,
  TargetCapacityUnitType,
} from "./models_1";
import {
  NetworkInsightsAccessScopeContent,
  SSEType,
  SubnetCidrReservation,
  TransitGatewayPrefixListReference,
} from "./models_2";
import {
  ConversionTask,
  ExportTaskS3Location,
  FastLaunchLaunchTemplateSpecificationResponse,
  FastLaunchResourceType,
  FastLaunchSnapshotConfigurationResponse,
  FastLaunchStateCode,
  FastSnapshotRestoreStateCode,
  Filter,
  IpamPoolCidr,
  MetricType,
  PeriodType,
  StatisticType,
} from "./models_3";
import {
  AnalysisStatus,
  ArchitectureType,
  ArchitectureValues,
  AttributeBooleanValue,
  BootModeValues,
  FpgaImageAttribute,
  FpgaImageAttributeName,
  HttpTokensState,
  ImportImageLicenseConfigurationResponse,
  InstanceAttributeName,
  InstanceMetadataEndpointState,
  InstanceMetadataTagsState,
  InstanceStatusEvent,
  LaunchPermission,
  LockState,
  PaymentOption,
  PermissionGroup,
  SnapshotDetail,
  SnapshotTaskDetail,
  VirtualizationType,
} from "./models_4";
import {
  ManagedBy,
  SnapshotBlockPublicAccessState,
  TransitGatewayPropagation,
  TransitGatewayPropagationState,
} from "./models_5";
export interface EnableAddressTransferResult {
  AddressTransfer?: AddressTransfer | undefined;
}
export interface EnableAllowedImagesSettingsRequest {
  AllowedImagesSettingsState: AllowedImagesSettingsEnabledState | undefined;
  DryRun?: boolean | undefined;
}
export interface EnableAllowedImagesSettingsResult {
  AllowedImagesSettingsState?: AllowedImagesSettingsEnabledState | undefined;
}
export interface EnableAwsNetworkPerformanceMetricSubscriptionRequest {
  Source?: string | undefined;
  Destination?: string | undefined;
  Metric?: MetricType | undefined;
  Statistic?: StatisticType | undefined;
  DryRun?: boolean | undefined;
}
export interface EnableAwsNetworkPerformanceMetricSubscriptionResult {
  Output?: boolean | undefined;
}
export interface EnableEbsEncryptionByDefaultRequest {
  DryRun?: boolean | undefined;
}
export interface EnableEbsEncryptionByDefaultResult {
  EbsEncryptionByDefault?: boolean | undefined;
}
export interface FastLaunchLaunchTemplateSpecificationRequest {
  LaunchTemplateId?: string | undefined;
  LaunchTemplateName?: string | undefined;
  Version: string | undefined;
}
export interface FastLaunchSnapshotConfigurationRequest {
  TargetResourceCount?: number | undefined;
}
export interface EnableFastLaunchRequest {
  ImageId: string | undefined;
  ResourceType?: string | undefined;
  SnapshotConfiguration?: FastLaunchSnapshotConfigurationRequest | undefined;
  LaunchTemplate?: FastLaunchLaunchTemplateSpecificationRequest | undefined;
  MaxParallelLaunches?: number | undefined;
  DryRun?: boolean | undefined;
}
export interface EnableFastLaunchResult {
  ImageId?: string | undefined;
  ResourceType?: FastLaunchResourceType | undefined;
  SnapshotConfiguration?: FastLaunchSnapshotConfigurationResponse | undefined;
  LaunchTemplate?: FastLaunchLaunchTemplateSpecificationResponse | undefined;
  MaxParallelLaunches?: number | undefined;
  OwnerId?: string | undefined;
  State?: FastLaunchStateCode | undefined;
  StateTransitionReason?: string | undefined;
  StateTransitionTime?: Date | undefined;
}
export interface EnableFastSnapshotRestoresRequest {
  AvailabilityZones: string[] | undefined;
  SourceSnapshotIds: string[] | undefined;
  DryRun?: boolean | undefined;
}
export interface EnableFastSnapshotRestoreSuccessItem {
  SnapshotId?: string | undefined;
  AvailabilityZone?: string | undefined;
  State?: FastSnapshotRestoreStateCode | undefined;
  StateTransitionReason?: string | undefined;
  OwnerId?: string | undefined;
  OwnerAlias?: string | undefined;
  EnablingTime?: Date | undefined;
  OptimizingTime?: Date | undefined;
  EnabledTime?: Date | undefined;
  DisablingTime?: Date | undefined;
  DisabledTime?: Date | undefined;
}
export interface EnableFastSnapshotRestoreStateError {
  Code?: string | undefined;
  Message?: string | undefined;
}
export interface EnableFastSnapshotRestoreStateErrorItem {
  AvailabilityZone?: string | undefined;
  Error?: EnableFastSnapshotRestoreStateError | undefined;
}
export interface EnableFastSnapshotRestoreErrorItem {
  SnapshotId?: string | undefined;
  FastSnapshotRestoreStateErrors?:
    | EnableFastSnapshotRestoreStateErrorItem[]
    | undefined;
}
export interface EnableFastSnapshotRestoresResult {
  Successful?: EnableFastSnapshotRestoreSuccessItem[] | undefined;
  Unsuccessful?: EnableFastSnapshotRestoreErrorItem[] | undefined;
}
export interface EnableImageRequest {
  ImageId: string | undefined;
  DryRun?: boolean | undefined;
}
export interface EnableImageResult {
  Return?: boolean | undefined;
}
export declare const ImageBlockPublicAccessEnabledState: {
  readonly block_new_sharing: "block-new-sharing";
};
export type ImageBlockPublicAccessEnabledState =
  (typeof ImageBlockPublicAccessEnabledState)[keyof typeof ImageBlockPublicAccessEnabledState];
export interface EnableImageBlockPublicAccessRequest {
  ImageBlockPublicAccessState: ImageBlockPublicAccessEnabledState | undefined;
  DryRun?: boolean | undefined;
}
export interface EnableImageBlockPublicAccessResult {
  ImageBlockPublicAccessState?: ImageBlockPublicAccessEnabledState | undefined;
}
export interface EnableImageDeprecationRequest {
  ImageId: string | undefined;
  DeprecateAt: Date | undefined;
  DryRun?: boolean | undefined;
}
export interface EnableImageDeprecationResult {
  Return?: boolean | undefined;
}
export interface EnableImageDeregistrationProtectionRequest {
  ImageId: string | undefined;
  WithCooldown?: boolean | undefined;
  DryRun?: boolean | undefined;
}
export interface EnableImageDeregistrationProtectionResult {
  Return?: string | undefined;
}
export interface EnableIpamOrganizationAdminAccountRequest {
  DryRun?: boolean | undefined;
  DelegatedAdminAccountId: string | undefined;
}
export interface EnableIpamOrganizationAdminAccountResult {
  Success?: boolean | undefined;
}
export interface EnableReachabilityAnalyzerOrganizationSharingRequest {
  DryRun?: boolean | undefined;
}
export interface EnableReachabilityAnalyzerOrganizationSharingResult {
  ReturnValue?: boolean | undefined;
}
export interface EnableSerialConsoleAccessRequest {
  DryRun?: boolean | undefined;
}
export interface EnableSerialConsoleAccessResult {
  SerialConsoleAccessEnabled?: boolean | undefined;
}
export interface EnableSnapshotBlockPublicAccessRequest {
  State: SnapshotBlockPublicAccessState | undefined;
  DryRun?: boolean | undefined;
}
export interface EnableSnapshotBlockPublicAccessResult {
  State?: SnapshotBlockPublicAccessState | undefined;
}
export interface EnableTransitGatewayRouteTablePropagationRequest {
  TransitGatewayRouteTableId: string | undefined;
  TransitGatewayAttachmentId?: string | undefined;
  DryRun?: boolean | undefined;
  TransitGatewayRouteTableAnnouncementId?: string | undefined;
}
export interface EnableTransitGatewayRouteTablePropagationResult {
  Propagation?: TransitGatewayPropagation | undefined;
}
export interface EnableVgwRoutePropagationRequest {
  GatewayId: string | undefined;
  RouteTableId: string | undefined;
  DryRun?: boolean | undefined;
}
export interface EnableVolumeIORequest {
  DryRun?: boolean | undefined;
  VolumeId: string | undefined;
}
export interface EnableVpcClassicLinkRequest {
  DryRun?: boolean | undefined;
  VpcId: string | undefined;
}
export interface EnableVpcClassicLinkResult {
  Return?: boolean | undefined;
}
export interface EnableVpcClassicLinkDnsSupportRequest {
  VpcId?: string | undefined;
}
export interface EnableVpcClassicLinkDnsSupportResult {
  Return?: boolean | undefined;
}
export interface ExportClientVpnClientCertificateRevocationListRequest {
  ClientVpnEndpointId: string | undefined;
  DryRun?: boolean | undefined;
}
export declare const ClientCertificateRevocationListStatusCode: {
  readonly active: "active";
  readonly pending: "pending";
};
export type ClientCertificateRevocationListStatusCode =
  (typeof ClientCertificateRevocationListStatusCode)[keyof typeof ClientCertificateRevocationListStatusCode];
export interface ClientCertificateRevocationListStatus {
  Code?: ClientCertificateRevocationListStatusCode | undefined;
  Message?: string | undefined;
}
export interface ExportClientVpnClientCertificateRevocationListResult {
  CertificateRevocationList?: string | undefined;
  Status?: ClientCertificateRevocationListStatus | undefined;
}
export interface ExportClientVpnClientConfigurationRequest {
  ClientVpnEndpointId: string | undefined;
  DryRun?: boolean | undefined;
}
export interface ExportClientVpnClientConfigurationResult {
  ClientConfiguration?: string | undefined;
}
export interface ExportTaskS3LocationRequest {
  S3Bucket: string | undefined;
  S3Prefix?: string | undefined;
}
export interface ExportImageRequest {
  ClientToken?: string | undefined;
  Description?: string | undefined;
  DiskImageFormat: DiskImageFormat | undefined;
  DryRun?: boolean | undefined;
  ImageId: string | undefined;
  S3ExportLocation: ExportTaskS3LocationRequest | undefined;
  RoleName?: string | undefined;
  TagSpecifications?: TagSpecification[] | undefined;
}
export interface ExportImageResult {
  Description?: string | undefined;
  DiskImageFormat?: DiskImageFormat | undefined;
  ExportImageTaskId?: string | undefined;
  ImageId?: string | undefined;
  RoleName?: string | undefined;
  Progress?: string | undefined;
  S3ExportLocation?: ExportTaskS3Location | undefined;
  Status?: string | undefined;
  StatusMessage?: string | undefined;
  Tags?: Tag[] | undefined;
}
export interface ExportTransitGatewayRoutesRequest {
  TransitGatewayRouteTableId: string | undefined;
  Filters?: Filter[] | undefined;
  S3Bucket: string | undefined;
  DryRun?: boolean | undefined;
}
export interface ExportTransitGatewayRoutesResult {
  S3Location?: string | undefined;
}
export interface ExportVerifiedAccessInstanceClientConfigurationRequest {
  VerifiedAccessInstanceId: string | undefined;
  DryRun?: boolean | undefined;
}
export interface VerifiedAccessInstanceOpenVpnClientConfigurationRoute {
  Cidr?: string | undefined;
}
export interface VerifiedAccessInstanceOpenVpnClientConfiguration {
  Config?: string | undefined;
  Routes?: VerifiedAccessInstanceOpenVpnClientConfigurationRoute[] | undefined;
}
export interface VerifiedAccessInstanceUserTrustProviderClientConfiguration {
  Type?: UserTrustProviderType | undefined;
  Scopes?: string | undefined;
  Issuer?: string | undefined;
  AuthorizationEndpoint?: string | undefined;
  PublicSigningKeyEndpoint?: string | undefined;
  TokenEndpoint?: string | undefined;
  UserInfoEndpoint?: string | undefined;
  ClientId?: string | undefined;
  ClientSecret?: string | undefined;
  PkceEnabled?: boolean | undefined;
}
export interface ExportVerifiedAccessInstanceClientConfigurationResult {
  Version?: string | undefined;
  VerifiedAccessInstanceId?: string | undefined;
  Region?: string | undefined;
  DeviceTrustProviders?: DeviceTrustProviderType[] | undefined;
  UserTrustProvider?:
    | VerifiedAccessInstanceUserTrustProviderClientConfiguration
    | undefined;
  OpenVpnConfigurations?:
    | VerifiedAccessInstanceOpenVpnClientConfiguration[]
    | undefined;
}
export interface GetAllowedImagesSettingsRequest {
  DryRun?: boolean | undefined;
}
export interface ImageCriterion {
  ImageProviders?: string[] | undefined;
}
export interface GetAllowedImagesSettingsResult {
  State?: string | undefined;
  ImageCriteria?: ImageCriterion[] | undefined;
  ManagedBy?: ManagedBy | undefined;
}
export interface GetAssociatedEnclaveCertificateIamRolesRequest {
  CertificateArn: string | undefined;
  DryRun?: boolean | undefined;
}
export interface AssociatedRole {
  AssociatedRoleArn?: string | undefined;
  CertificateS3BucketName?: string | undefined;
  CertificateS3ObjectKey?: string | undefined;
  EncryptionKmsKeyId?: string | undefined;
}
export interface GetAssociatedEnclaveCertificateIamRolesResult {
  AssociatedRoles?: AssociatedRole[] | undefined;
}
export interface GetAssociatedIpv6PoolCidrsRequest {
  PoolId: string | undefined;
  NextToken?: string | undefined;
  MaxResults?: number | undefined;
  DryRun?: boolean | undefined;
}
export interface Ipv6CidrAssociation {
  Ipv6Cidr?: string | undefined;
  AssociatedResource?: string | undefined;
}
export interface GetAssociatedIpv6PoolCidrsResult {
  Ipv6CidrAssociations?: Ipv6CidrAssociation[] | undefined;
  NextToken?: string | undefined;
}
export interface DataQuery {
  Id?: string | undefined;
  Source?: string | undefined;
  Destination?: string | undefined;
  Metric?: MetricType | undefined;
  Statistic?: StatisticType | undefined;
  Period?: PeriodType | undefined;
}
export interface GetAwsNetworkPerformanceDataRequest {
  DataQueries?: DataQuery[] | undefined;
  StartTime?: Date | undefined;
  EndTime?: Date | undefined;
  MaxResults?: number | undefined;
  NextToken?: string | undefined;
  DryRun?: boolean | undefined;
}
export interface MetricPoint {
  StartDate?: Date | undefined;
  EndDate?: Date | undefined;
  Value?: number | undefined;
  Status?: string | undefined;
}
export interface DataResponse {
  Id?: string | undefined;
  Source?: string | undefined;
  Destination?: string | undefined;
  Metric?: MetricType | undefined;
  Statistic?: StatisticType | undefined;
  Period?: PeriodType | undefined;
  MetricPoints?: MetricPoint[] | undefined;
}
export interface GetAwsNetworkPerformanceDataResult {
  DataResponses?: DataResponse[] | undefined;
  NextToken?: string | undefined;
}
export interface GetCapacityReservationUsageRequest {
  CapacityReservationId: string | undefined;
  NextToken?: string | undefined;
  MaxResults?: number | undefined;
  DryRun?: boolean | undefined;
}
export interface InstanceUsage {
  AccountId?: string | undefined;
  UsedInstanceCount?: number | undefined;
}
export interface GetCapacityReservationUsageResult {
  NextToken?: string | undefined;
  CapacityReservationId?: string | undefined;
  InstanceType?: string | undefined;
  TotalInstanceCount?: number | undefined;
  AvailableInstanceCount?: number | undefined;
  State?: CapacityReservationState | undefined;
  InstanceUsages?: InstanceUsage[] | undefined;
}
export interface GetCoipPoolUsageRequest {
  PoolId: string | undefined;
  Filters?: Filter[] | undefined;
  MaxResults?: number | undefined;
  NextToken?: string | undefined;
  DryRun?: boolean | undefined;
}
export interface CoipAddressUsage {
  AllocationId?: string | undefined;
  AwsAccountId?: string | undefined;
  AwsService?: string | undefined;
  CoIp?: string | undefined;
}
export interface GetCoipPoolUsageResult {
  CoipPoolId?: string | undefined;
  CoipAddressUsages?: CoipAddressUsage[] | undefined;
  LocalGatewayRouteTableId?: string | undefined;
  NextToken?: string | undefined;
}
export interface GetConsoleOutputRequest {
  InstanceId: string | undefined;
  Latest?: boolean | undefined;
  DryRun?: boolean | undefined;
}
export interface GetConsoleOutputResult {
  InstanceId?: string | undefined;
  Timestamp?: Date | undefined;
  Output?: string | undefined;
}
export interface GetConsoleScreenshotRequest {
  DryRun?: boolean | undefined;
  InstanceId: string | undefined;
  WakeUp?: boolean | undefined;
}
export interface GetConsoleScreenshotResult {
  ImageData?: string | undefined;
  InstanceId?: string | undefined;
}
export interface GetDeclarativePoliciesReportSummaryRequest {
  DryRun?: boolean | undefined;
  ReportId: string | undefined;
}
export interface RegionalSummary {
  RegionName?: string | undefined;
  NumberOfMatchedAccounts?: number | undefined;
  NumberOfUnmatchedAccounts?: number | undefined;
}
export interface AttributeSummary {
  AttributeName?: string | undefined;
  MostFrequentValue?: string | undefined;
  NumberOfMatchedAccounts?: number | undefined;
  NumberOfUnmatchedAccounts?: number | undefined;
  RegionalSummaries?: RegionalSummary[] | undefined;
}
export interface GetDeclarativePoliciesReportSummaryResult {
  ReportId?: string | undefined;
  S3Bucket?: string | undefined;
  S3Prefix?: string | undefined;
  TargetId?: string | undefined;
  StartTime?: Date | undefined;
  EndTime?: Date | undefined;
  NumberOfAccounts?: number | undefined;
  NumberOfFailedAccounts?: number | undefined;
  AttributeSummaries?: AttributeSummary[] | undefined;
}
export declare const UnlimitedSupportedInstanceFamily: {
  readonly t2: "t2";
  readonly t3: "t3";
  readonly t3a: "t3a";
  readonly t4g: "t4g";
};
export type UnlimitedSupportedInstanceFamily =
  (typeof UnlimitedSupportedInstanceFamily)[keyof typeof UnlimitedSupportedInstanceFamily];
export interface GetDefaultCreditSpecificationRequest {
  DryRun?: boolean | undefined;
  InstanceFamily: UnlimitedSupportedInstanceFamily | undefined;
}
export interface InstanceFamilyCreditSpecification {
  InstanceFamily?: UnlimitedSupportedInstanceFamily | undefined;
  CpuCredits?: string | undefined;
}
export interface GetDefaultCreditSpecificationResult {
  InstanceFamilyCreditSpecification?:
    | InstanceFamilyCreditSpecification
    | undefined;
}
export interface GetEbsDefaultKmsKeyIdRequest {
  DryRun?: boolean | undefined;
}
export interface GetEbsDefaultKmsKeyIdResult {
  KmsKeyId?: string | undefined;
}
export interface GetEbsEncryptionByDefaultRequest {
  DryRun?: boolean | undefined;
}
export interface GetEbsEncryptionByDefaultResult {
  EbsEncryptionByDefault?: boolean | undefined;
  SseType?: SSEType | undefined;
}
export declare const PartitionLoadFrequency: {
  readonly DAILY: "daily";
  readonly MONTHLY: "monthly";
  readonly NONE: "none";
  readonly WEEKLY: "weekly";
};
export type PartitionLoadFrequency =
  (typeof PartitionLoadFrequency)[keyof typeof PartitionLoadFrequency];
export interface AthenaIntegration {
  IntegrationResultS3DestinationArn: string | undefined;
  PartitionLoadFrequency: PartitionLoadFrequency | undefined;
  PartitionStartDate?: Date | undefined;
  PartitionEndDate?: Date | undefined;
}
export interface IntegrateServices {
  AthenaIntegrations?: AthenaIntegration[] | undefined;
}
export interface GetFlowLogsIntegrationTemplateRequest {
  DryRun?: boolean | undefined;
  FlowLogId: string | undefined;
  ConfigDeliveryS3DestinationArn: string | undefined;
  IntegrateServices: IntegrateServices | undefined;
}
export interface GetFlowLogsIntegrationTemplateResult {
  Result?: string | undefined;
}
export interface GetGroupsForCapacityReservationRequest {
  CapacityReservationId: string | undefined;
  NextToken?: string | undefined;
  MaxResults?: number | undefined;
  DryRun?: boolean | undefined;
}
export interface CapacityReservationGroup {
  GroupArn?: string | undefined;
  OwnerId?: string | undefined;
}
export interface GetGroupsForCapacityReservationResult {
  NextToken?: string | undefined;
  CapacityReservationGroups?: CapacityReservationGroup[] | undefined;
}
export interface GetHostReservationPurchasePreviewRequest {
  HostIdSet: string[] | undefined;
  OfferingId: string | undefined;
}
export interface Purchase {
  CurrencyCode?: CurrencyCodeValues | undefined;
  Duration?: number | undefined;
  HostIdSet?: string[] | undefined;
  HostReservationId?: string | undefined;
  HourlyPrice?: string | undefined;
  InstanceFamily?: string | undefined;
  PaymentOption?: PaymentOption | undefined;
  UpfrontPrice?: string | undefined;
}
export interface GetHostReservationPurchasePreviewResult {
  CurrencyCode?: CurrencyCodeValues | undefined;
  Purchase?: Purchase[] | undefined;
  TotalHourlyPrice?: string | undefined;
  TotalUpfrontPrice?: string | undefined;
}
export interface GetImageBlockPublicAccessStateRequest {
  DryRun?: boolean | undefined;
}
export interface GetImageBlockPublicAccessStateResult {
  ImageBlockPublicAccessState?: string | undefined;
  ManagedBy?: ManagedBy | undefined;
}
export interface GetInstanceMetadataDefaultsRequest {
  DryRun?: boolean | undefined;
}
export interface InstanceMetadataDefaultsResponse {
  HttpTokens?: HttpTokensState | undefined;
  HttpPutResponseHopLimit?: number | undefined;
  HttpEndpoint?: InstanceMetadataEndpointState | undefined;
  InstanceMetadataTags?: InstanceMetadataTagsState | undefined;
  ManagedBy?: ManagedBy | undefined;
  ManagedExceptionMessage?: string | undefined;
}
export interface GetInstanceMetadataDefaultsResult {
  AccountLevel?: InstanceMetadataDefaultsResponse | undefined;
}
export declare const EkPubKeyFormat: {
  readonly der: "der";
  readonly tpmt: "tpmt";
};
export type EkPubKeyFormat =
  (typeof EkPubKeyFormat)[keyof typeof EkPubKeyFormat];
export declare const EkPubKeyType: {
  readonly ECC_SEC_P384: "ecc-sec-p384";
  readonly RSA_2048: "rsa-2048";
};
export type EkPubKeyType = (typeof EkPubKeyType)[keyof typeof EkPubKeyType];
export interface GetInstanceTpmEkPubRequest {
  InstanceId: string | undefined;
  KeyType: EkPubKeyType | undefined;
  KeyFormat: EkPubKeyFormat | undefined;
  DryRun?: boolean | undefined;
}
export interface GetInstanceTpmEkPubResult {
  InstanceId?: string | undefined;
  KeyType?: EkPubKeyType | undefined;
  KeyFormat?: EkPubKeyFormat | undefined;
  KeyValue?: string | undefined;
}
export interface GetInstanceTypesFromInstanceRequirementsRequest {
  DryRun?: boolean | undefined;
  ArchitectureTypes: ArchitectureType[] | undefined;
  VirtualizationTypes: VirtualizationType[] | undefined;
  InstanceRequirements: InstanceRequirementsRequest | undefined;
  MaxResults?: number | undefined;
  NextToken?: string | undefined;
}
export interface InstanceTypeInfoFromInstanceRequirements {
  InstanceType?: string | undefined;
}
export interface GetInstanceTypesFromInstanceRequirementsResult {
  InstanceTypes?: InstanceTypeInfoFromInstanceRequirements[] | undefined;
  NextToken?: string | undefined;
}
export interface GetInstanceUefiDataRequest {
  InstanceId: string | undefined;
  DryRun?: boolean | undefined;
}
export interface GetInstanceUefiDataResult {
  InstanceId?: string | undefined;
  UefiData?: string | undefined;
}
export interface GetIpamAddressHistoryRequest {
  DryRun?: boolean | undefined;
  Cidr: string | undefined;
  IpamScopeId: string | undefined;
  VpcId?: string | undefined;
  StartTime?: Date | undefined;
  EndTime?: Date | undefined;
  MaxResults?: number | undefined;
  NextToken?: string | undefined;
}
export declare const IpamComplianceStatus: {
  readonly compliant: "compliant";
  readonly ignored: "ignored";
  readonly noncompliant: "noncompliant";
  readonly unmanaged: "unmanaged";
};
export type IpamComplianceStatus =
  (typeof IpamComplianceStatus)[keyof typeof IpamComplianceStatus];
export declare const IpamOverlapStatus: {
  readonly ignored: "ignored";
  readonly nonoverlapping: "nonoverlapping";
  readonly overlapping: "overlapping";
};
export type IpamOverlapStatus =
  (typeof IpamOverlapStatus)[keyof typeof IpamOverlapStatus];
export declare const IpamAddressHistoryResourceType: {
  readonly eip: "eip";
  readonly instance: "instance";
  readonly network_interface: "network-interface";
  readonly subnet: "subnet";
  readonly vpc: "vpc";
};
export type IpamAddressHistoryResourceType =
  (typeof IpamAddressHistoryResourceType)[keyof typeof IpamAddressHistoryResourceType];
export interface IpamAddressHistoryRecord {
  ResourceOwnerId?: string | undefined;
  ResourceRegion?: string | undefined;
  ResourceType?: IpamAddressHistoryResourceType | undefined;
  ResourceId?: string | undefined;
  ResourceCidr?: string | undefined;
  ResourceName?: string | undefined;
  ResourceComplianceStatus?: IpamComplianceStatus | undefined;
  ResourceOverlapStatus?: IpamOverlapStatus | undefined;
  VpcId?: string | undefined;
  SampledStartTime?: Date | undefined;
  SampledEndTime?: Date | undefined;
}
export interface GetIpamAddressHistoryResult {
  HistoryRecords?: IpamAddressHistoryRecord[] | undefined;
  NextToken?: string | undefined;
}
export interface GetIpamDiscoveredAccountsRequest {
  DryRun?: boolean | undefined;
  IpamResourceDiscoveryId: string | undefined;
  DiscoveryRegion: string | undefined;
  Filters?: Filter[] | undefined;
  NextToken?: string | undefined;
  MaxResults?: number | undefined;
}
export declare const IpamDiscoveryFailureCode: {
  readonly assume_role_failure: "assume-role-failure";
  readonly throttling_failure: "throttling-failure";
  readonly unauthorized_failure: "unauthorized-failure";
};
export type IpamDiscoveryFailureCode =
  (typeof IpamDiscoveryFailureCode)[keyof typeof IpamDiscoveryFailureCode];
export interface IpamDiscoveryFailureReason {
  Code?: IpamDiscoveryFailureCode | undefined;
  Message?: string | undefined;
}
export interface IpamDiscoveredAccount {
  AccountId?: string | undefined;
  DiscoveryRegion?: string | undefined;
  FailureReason?: IpamDiscoveryFailureReason | undefined;
  LastAttemptedDiscoveryTime?: Date | undefined;
  LastSuccessfulDiscoveryTime?: Date | undefined;
  OrganizationalUnitId?: string | undefined;
}
export interface GetIpamDiscoveredAccountsResult {
  IpamDiscoveredAccounts?: IpamDiscoveredAccount[] | undefined;
  NextToken?: string | undefined;
}
export interface GetIpamDiscoveredPublicAddressesRequest {
  DryRun?: boolean | undefined;
  IpamResourceDiscoveryId: string | undefined;
  AddressRegion: string | undefined;
  Filters?: Filter[] | undefined;
  NextToken?: string | undefined;
  MaxResults?: number | undefined;
}
export declare const IpamPublicAddressType: {
  readonly AMAZON_OWNED_CONTIG: "amazon-owned-contig";
  readonly AMAZON_OWNED_EIP: "amazon-owned-eip";
  readonly BYOIP: "byoip";
  readonly EC2_PUBLIC_IP: "ec2-public-ip";
  readonly SERVICE_MANAGED_BYOIP: "service-managed-byoip";
  readonly SERVICE_MANAGED_IP: "service-managed-ip";
};
export type IpamPublicAddressType =
  (typeof IpamPublicAddressType)[keyof typeof IpamPublicAddressType];
export declare const IpamPublicAddressAssociationStatus: {
  readonly ASSOCIATED: "associated";
  readonly DISASSOCIATED: "disassociated";
};
export type IpamPublicAddressAssociationStatus =
  (typeof IpamPublicAddressAssociationStatus)[keyof typeof IpamPublicAddressAssociationStatus];
export interface IpamPublicAddressSecurityGroup {
  GroupName?: string | undefined;
  GroupId?: string | undefined;
}
export declare const IpamPublicAddressAwsService: {
  readonly AGA: "global-accelerator";
  readonly DMS: "database-migration-service";
  readonly EC2_LB: "load-balancer";
  readonly ECS: "elastic-container-service";
  readonly NAT_GATEWAY: "nat-gateway";
  readonly OTHER: "other";
  readonly RDS: "relational-database-service";
  readonly REDSHIFT: "redshift";
  readonly S2S_VPN: "site-to-site-vpn";
};
export type IpamPublicAddressAwsService =
  (typeof IpamPublicAddressAwsService)[keyof typeof IpamPublicAddressAwsService];
export interface IpamPublicAddressTag {
  Key?: string | undefined;
  Value?: string | undefined;
}
export interface IpamPublicAddressTags {
  EipTags?: IpamPublicAddressTag[] | undefined;
}
export interface IpamDiscoveredPublicAddress {
  IpamResourceDiscoveryId?: string | undefined;
  AddressRegion?: string | undefined;
  Address?: string | undefined;
  AddressOwnerId?: string | undefined;
  AddressAllocationId?: string | undefined;
  AssociationStatus?: IpamPublicAddressAssociationStatus | undefined;
  AddressType?: IpamPublicAddressType | undefined;
  Service?: IpamPublicAddressAwsService | undefined;
  ServiceResource?: string | undefined;
  VpcId?: string | undefined;
  SubnetId?: string | undefined;
  PublicIpv4PoolId?: string | undefined;
  NetworkInterfaceId?: string | undefined;
  NetworkInterfaceDescription?: string | undefined;
  InstanceId?: string | undefined;
  Tags?: IpamPublicAddressTags | undefined;
  NetworkBorderGroup?: string | undefined;
  SecurityGroups?: IpamPublicAddressSecurityGroup[] | undefined;
  SampleTime?: Date | undefined;
}
export interface GetIpamDiscoveredPublicAddressesResult {
  IpamDiscoveredPublicAddresses?: IpamDiscoveredPublicAddress[] | undefined;
  OldestSampleTime?: Date | undefined;
  NextToken?: string | undefined;
}
export interface GetIpamDiscoveredResourceCidrsRequest {
  DryRun?: boolean | undefined;
  IpamResourceDiscoveryId: string | undefined;
  ResourceRegion: string | undefined;
  Filters?: Filter[] | undefined;
  NextToken?: string | undefined;
  MaxResults?: number | undefined;
}
export declare const IpamResourceCidrIpSource: {
  readonly amazon: "amazon";
  readonly byoip: "byoip";
  readonly none: "none";
};
export type IpamResourceCidrIpSource =
  (typeof IpamResourceCidrIpSource)[keyof typeof IpamResourceCidrIpSource];
export declare const IpamNetworkInterfaceAttachmentStatus: {
  readonly available: "available";
  readonly in_use: "in-use";
};
export type IpamNetworkInterfaceAttachmentStatus =
  (typeof IpamNetworkInterfaceAttachmentStatus)[keyof typeof IpamNetworkInterfaceAttachmentStatus];
export declare const IpamResourceType: {
  readonly eip: "eip";
  readonly eni: "eni";
  readonly ipv6_pool: "ipv6-pool";
  readonly public_ipv4_pool: "public-ipv4-pool";
  readonly subnet: "subnet";
  readonly vpc: "vpc";
};
export type IpamResourceType =
  (typeof IpamResourceType)[keyof typeof IpamResourceType];
export interface IpamDiscoveredResourceCidr {
  IpamResourceDiscoveryId?: string | undefined;
  ResourceRegion?: string | undefined;
  ResourceId?: string | undefined;
  ResourceOwnerId?: string | undefined;
  ResourceCidr?: string | undefined;
  IpSource?: IpamResourceCidrIpSource | undefined;
  ResourceType?: IpamResourceType | undefined;
  ResourceTags?: IpamResourceTag[] | undefined;
  IpUsage?: number | undefined;
  VpcId?: string | undefined;
  SubnetId?: string | undefined;
  NetworkInterfaceAttachmentStatus?:
    | IpamNetworkInterfaceAttachmentStatus
    | undefined;
  SampleTime?: Date | undefined;
  AvailabilityZoneId?: string | undefined;
}
export interface GetIpamDiscoveredResourceCidrsResult {
  IpamDiscoveredResourceCidrs?: IpamDiscoveredResourceCidr[] | undefined;
  NextToken?: string | undefined;
}
export interface GetIpamPoolAllocationsRequest {
  DryRun?: boolean | undefined;
  IpamPoolId: string | undefined;
  IpamPoolAllocationId?: string | undefined;
  Filters?: Filter[] | undefined;
  MaxResults?: number | undefined;
  NextToken?: string | undefined;
}
export interface GetIpamPoolAllocationsResult {
  IpamPoolAllocations?: IpamPoolAllocation[] | undefined;
  NextToken?: string | undefined;
}
export interface GetIpamPoolCidrsRequest {
  DryRun?: boolean | undefined;
  IpamPoolId: string | undefined;
  Filters?: Filter[] | undefined;
  MaxResults?: number | undefined;
  NextToken?: string | undefined;
}
export interface GetIpamPoolCidrsResult {
  IpamPoolCidrs?: IpamPoolCidr[] | undefined;
  NextToken?: string | undefined;
}
export interface GetIpamResourceCidrsRequest {
  DryRun?: boolean | undefined;
  Filters?: Filter[] | undefined;
  MaxResults?: number | undefined;
  NextToken?: string | undefined;
  IpamScopeId: string | undefined;
  IpamPoolId?: string | undefined;
  ResourceId?: string | undefined;
  ResourceType?: IpamResourceType | undefined;
  ResourceTag?: RequestIpamResourceTag | undefined;
  ResourceOwner?: string | undefined;
}
export declare const IpamManagementState: {
  readonly ignored: "ignored";
  readonly managed: "managed";
  readonly unmanaged: "unmanaged";
};
export type IpamManagementState =
  (typeof IpamManagementState)[keyof typeof IpamManagementState];
export interface IpamResourceCidr {
  IpamId?: string | undefined;
  IpamScopeId?: string | undefined;
  IpamPoolId?: string | undefined;
  ResourceRegion?: string | undefined;
  ResourceOwnerId?: string | undefined;
  ResourceId?: string | undefined;
  ResourceName?: string | undefined;
  ResourceCidr?: string | undefined;
  ResourceType?: IpamResourceType | undefined;
  ResourceTags?: IpamResourceTag[] | undefined;
  IpUsage?: number | undefined;
  ComplianceStatus?: IpamComplianceStatus | undefined;
  ManagementState?: IpamManagementState | undefined;
  OverlapStatus?: IpamOverlapStatus | undefined;
  VpcId?: string | undefined;
  AvailabilityZoneId?: string | undefined;
}
export interface GetIpamResourceCidrsResult {
  NextToken?: string | undefined;
  IpamResourceCidrs?: IpamResourceCidr[] | undefined;
}
export interface GetLaunchTemplateDataRequest {
  DryRun?: boolean | undefined;
  InstanceId: string | undefined;
}
export interface GetLaunchTemplateDataResult {
  LaunchTemplateData?: ResponseLaunchTemplateData | undefined;
}
export interface GetManagedPrefixListAssociationsRequest {
  DryRun?: boolean | undefined;
  PrefixListId: string | undefined;
  MaxResults?: number | undefined;
  NextToken?: string | undefined;
}
export interface PrefixListAssociation {
  ResourceId?: string | undefined;
  ResourceOwner?: string | undefined;
}
export interface GetManagedPrefixListAssociationsResult {
  PrefixListAssociations?: PrefixListAssociation[] | undefined;
  NextToken?: string | undefined;
}
export interface GetManagedPrefixListEntriesRequest {
  DryRun?: boolean | undefined;
  PrefixListId: string | undefined;
  TargetVersion?: number | undefined;
  MaxResults?: number | undefined;
  NextToken?: string | undefined;
}
export interface PrefixListEntry {
  Cidr?: string | undefined;
  Description?: string | undefined;
}
export interface GetManagedPrefixListEntriesResult {
  Entries?: PrefixListEntry[] | undefined;
  NextToken?: string | undefined;
}
export interface GetNetworkInsightsAccessScopeAnalysisFindingsRequest {
  NetworkInsightsAccessScopeAnalysisId: string | undefined;
  MaxResults?: number | undefined;
  NextToken?: string | undefined;
  DryRun?: boolean | undefined;
}
export interface GetNetworkInsightsAccessScopeAnalysisFindingsResult {
  NetworkInsightsAccessScopeAnalysisId?: string | undefined;
  AnalysisStatus?: AnalysisStatus | undefined;
  AnalysisFindings?: AccessScopeAnalysisFinding[] | undefined;
  NextToken?: string | undefined;
}
export interface GetNetworkInsightsAccessScopeContentRequest {
  NetworkInsightsAccessScopeId: string | undefined;
  DryRun?: boolean | undefined;
}
export interface GetNetworkInsightsAccessScopeContentResult {
  NetworkInsightsAccessScopeContent?:
    | NetworkInsightsAccessScopeContent
    | undefined;
}
export interface GetPasswordDataRequest {
  InstanceId: string | undefined;
  DryRun?: boolean | undefined;
}
export interface GetPasswordDataResult {
  InstanceId?: string | undefined;
  Timestamp?: Date | undefined;
  PasswordData?: string | undefined;
}
export interface GetReservedInstancesExchangeQuoteRequest {
  DryRun?: boolean | undefined;
  ReservedInstanceIds: string[] | undefined;
  TargetConfigurations?: TargetConfigurationRequest[] | undefined;
}
export interface ReservationValue {
  HourlyPrice?: string | undefined;
  RemainingTotalValue?: string | undefined;
  RemainingUpfrontValue?: string | undefined;
}
export interface ReservedInstanceReservationValue {
  ReservationValue?: ReservationValue | undefined;
  ReservedInstanceId?: string | undefined;
}
export interface TargetConfiguration {
  InstanceCount?: number | undefined;
  OfferingId?: string | undefined;
}
export interface TargetReservationValue {
  ReservationValue?: ReservationValue | undefined;
  TargetConfiguration?: TargetConfiguration | undefined;
}
export interface GetReservedInstancesExchangeQuoteResult {
  CurrencyCode?: string | undefined;
  IsValidExchange?: boolean | undefined;
  OutputReservedInstancesWillExpireAt?: Date | undefined;
  PaymentDue?: string | undefined;
  ReservedInstanceValueRollup?: ReservationValue | undefined;
  ReservedInstanceValueSet?: ReservedInstanceReservationValue[] | undefined;
  TargetConfigurationValueRollup?: ReservationValue | undefined;
  TargetConfigurationValueSet?: TargetReservationValue[] | undefined;
  ValidationFailureReason?: string | undefined;
}
export interface GetSecurityGroupsForVpcRequest {
  VpcId: string | undefined;
  NextToken?: string | undefined;
  MaxResults?: number | undefined;
  Filters?: Filter[] | undefined;
  DryRun?: boolean | undefined;
}
export interface SecurityGroupForVpc {
  Description?: string | undefined;
  GroupName?: string | undefined;
  OwnerId?: string | undefined;
  GroupId?: string | undefined;
  Tags?: Tag[] | undefined;
  PrimaryVpcId?: string | undefined;
}
export interface GetSecurityGroupsForVpcResult {
  NextToken?: string | undefined;
  SecurityGroupForVpcs?: SecurityGroupForVpc[] | undefined;
}
export interface GetSerialConsoleAccessStatusRequest {
  DryRun?: boolean | undefined;
}
export interface GetSerialConsoleAccessStatusResult {
  SerialConsoleAccessEnabled?: boolean | undefined;
  ManagedBy?: ManagedBy | undefined;
}
export interface GetSnapshotBlockPublicAccessStateRequest {
  DryRun?: boolean | undefined;
}
export interface GetSnapshotBlockPublicAccessStateResult {
  State?: SnapshotBlockPublicAccessState | undefined;
  ManagedBy?: ManagedBy | undefined;
}
export interface InstanceRequirementsWithMetadataRequest {
  ArchitectureTypes?: ArchitectureType[] | undefined;
  VirtualizationTypes?: VirtualizationType[] | undefined;
  InstanceRequirements?: InstanceRequirementsRequest | undefined;
}
export interface GetSpotPlacementScoresRequest {
  InstanceTypes?: string[] | undefined;
  TargetCapacity: number | undefined;
  TargetCapacityUnitType?: TargetCapacityUnitType | undefined;
  SingleAvailabilityZone?: boolean | undefined;
  RegionNames?: string[] | undefined;
  InstanceRequirementsWithMetadata?:
    | InstanceRequirementsWithMetadataRequest
    | undefined;
  DryRun?: boolean | undefined;
  MaxResults?: number | undefined;
  NextToken?: string | undefined;
}
export interface SpotPlacementScore {
  Region?: string | undefined;
  AvailabilityZoneId?: string | undefined;
  Score?: number | undefined;
}
export interface GetSpotPlacementScoresResult {
  SpotPlacementScores?: SpotPlacementScore[] | undefined;
  NextToken?: string | undefined;
}
export interface GetSubnetCidrReservationsRequest {
  Filters?: Filter[] | undefined;
  SubnetId: string | undefined;
  DryRun?: boolean | undefined;
  NextToken?: string | undefined;
  MaxResults?: number | undefined;
}
export interface GetSubnetCidrReservationsResult {
  SubnetIpv4CidrReservations?: SubnetCidrReservation[] | undefined;
  SubnetIpv6CidrReservations?: SubnetCidrReservation[] | undefined;
  NextToken?: string | undefined;
}
export interface GetTransitGatewayAttachmentPropagationsRequest {
  TransitGatewayAttachmentId: string | undefined;
  Filters?: Filter[] | undefined;
  MaxResults?: number | undefined;
  NextToken?: string | undefined;
  DryRun?: boolean | undefined;
}
export interface TransitGatewayAttachmentPropagation {
  TransitGatewayRouteTableId?: string | undefined;
  State?: TransitGatewayPropagationState | undefined;
}
export interface GetTransitGatewayAttachmentPropagationsResult {
  TransitGatewayAttachmentPropagations?:
    | TransitGatewayAttachmentPropagation[]
    | undefined;
  NextToken?: string | undefined;
}
export interface GetTransitGatewayMulticastDomainAssociationsRequest {
  TransitGatewayMulticastDomainId: string | undefined;
  Filters?: Filter[] | undefined;
  MaxResults?: number | undefined;
  NextToken?: string | undefined;
  DryRun?: boolean | undefined;
}
export interface TransitGatewayMulticastDomainAssociation {
  TransitGatewayAttachmentId?: string | undefined;
  ResourceId?: string | undefined;
  ResourceType?: TransitGatewayAttachmentResourceType | undefined;
  ResourceOwnerId?: string | undefined;
  Subnet?: SubnetAssociation | undefined;
}
export interface GetTransitGatewayMulticastDomainAssociationsResult {
  MulticastDomainAssociations?:
    | TransitGatewayMulticastDomainAssociation[]
    | undefined;
  NextToken?: string | undefined;
}
export interface GetTransitGatewayPolicyTableAssociationsRequest {
  TransitGatewayPolicyTableId: string | undefined;
  Filters?: Filter[] | undefined;
  MaxResults?: number | undefined;
  NextToken?: string | undefined;
  DryRun?: boolean | undefined;
}
export interface GetTransitGatewayPolicyTableAssociationsResult {
  Associations?: TransitGatewayPolicyTableAssociation[] | undefined;
  NextToken?: string | undefined;
}
export interface GetTransitGatewayPolicyTableEntriesRequest {
  TransitGatewayPolicyTableId: string | undefined;
  Filters?: Filter[] | undefined;
  MaxResults?: number | undefined;
  NextToken?: string | undefined;
  DryRun?: boolean | undefined;
}
export interface TransitGatewayPolicyRuleMetaData {
  MetaDataKey?: string | undefined;
  MetaDataValue?: string | undefined;
}
export interface TransitGatewayPolicyRule {
  SourceCidrBlock?: string | undefined;
  SourcePortRange?: string | undefined;
  DestinationCidrBlock?: string | undefined;
  DestinationPortRange?: string | undefined;
  Protocol?: string | undefined;
  MetaData?: TransitGatewayPolicyRuleMetaData | undefined;
}
export interface TransitGatewayPolicyTableEntry {
  PolicyRuleNumber?: string | undefined;
  PolicyRule?: TransitGatewayPolicyRule | undefined;
  TargetRouteTableId?: string | undefined;
}
export interface GetTransitGatewayPolicyTableEntriesResult {
  TransitGatewayPolicyTableEntries?:
    | TransitGatewayPolicyTableEntry[]
    | undefined;
}
export interface GetTransitGatewayPrefixListReferencesRequest {
  TransitGatewayRouteTableId: string | undefined;
  Filters?: Filter[] | undefined;
  MaxResults?: number | undefined;
  NextToken?: string | undefined;
  DryRun?: boolean | undefined;
}
export interface GetTransitGatewayPrefixListReferencesResult {
  TransitGatewayPrefixListReferences?:
    | TransitGatewayPrefixListReference[]
    | undefined;
  NextToken?: string | undefined;
}
export interface GetTransitGatewayRouteTableAssociationsRequest {
  TransitGatewayRouteTableId: string | undefined;
  Filters?: Filter[] | undefined;
  MaxResults?: number | undefined;
  NextToken?: string | undefined;
  DryRun?: boolean | undefined;
}
export interface TransitGatewayRouteTableAssociation {
  TransitGatewayAttachmentId?: string | undefined;
  ResourceId?: string | undefined;
  ResourceType?: TransitGatewayAttachmentResourceType | undefined;
  State?: TransitGatewayAssociationState | undefined;
}
export interface GetTransitGatewayRouteTableAssociationsResult {
  Associations?: TransitGatewayRouteTableAssociation[] | undefined;
  NextToken?: string | undefined;
}
export interface GetTransitGatewayRouteTablePropagationsRequest {
  TransitGatewayRouteTableId: string | undefined;
  Filters?: Filter[] | undefined;
  MaxResults?: number | undefined;
  NextToken?: string | undefined;
  DryRun?: boolean | undefined;
}
export interface TransitGatewayRouteTablePropagation {
  TransitGatewayAttachmentId?: string | undefined;
  ResourceId?: string | undefined;
  ResourceType?: TransitGatewayAttachmentResourceType | undefined;
  State?: TransitGatewayPropagationState | undefined;
  TransitGatewayRouteTableAnnouncementId?: string | undefined;
}
export interface GetTransitGatewayRouteTablePropagationsResult {
  TransitGatewayRouteTablePropagations?:
    | TransitGatewayRouteTablePropagation[]
    | undefined;
  NextToken?: string | undefined;
}
export interface GetVerifiedAccessEndpointPolicyRequest {
  VerifiedAccessEndpointId: string | undefined;
  DryRun?: boolean | undefined;
}
export interface GetVerifiedAccessEndpointPolicyResult {
  PolicyEnabled?: boolean | undefined;
  PolicyDocument?: string | undefined;
}
export interface GetVerifiedAccessEndpointTargetsRequest {
  VerifiedAccessEndpointId: string | undefined;
  MaxResults?: number | undefined;
  NextToken?: string | undefined;
  DryRun?: boolean | undefined;
}
export interface VerifiedAccessEndpointTarget {
  VerifiedAccessEndpointId?: string | undefined;
  VerifiedAccessEndpointTargetIpAddress?: string | undefined;
  VerifiedAccessEndpointTargetDns?: string | undefined;
}
export interface GetVerifiedAccessEndpointTargetsResult {
  VerifiedAccessEndpointTargets?: VerifiedAccessEndpointTarget[] | undefined;
  NextToken?: string | undefined;
}
export interface GetVerifiedAccessGroupPolicyRequest {
  VerifiedAccessGroupId: string | undefined;
  DryRun?: boolean | undefined;
}
export interface GetVerifiedAccessGroupPolicyResult {
  PolicyEnabled?: boolean | undefined;
  PolicyDocument?: string | undefined;
}
export interface GetVpnConnectionDeviceSampleConfigurationRequest {
  VpnConnectionId: string | undefined;
  VpnConnectionDeviceTypeId: string | undefined;
  InternetKeyExchangeVersion?: string | undefined;
  DryRun?: boolean | undefined;
}
export interface GetVpnConnectionDeviceSampleConfigurationResult {
  VpnConnectionDeviceSampleConfiguration?: string | undefined;
}
export interface GetVpnConnectionDeviceTypesRequest {
  MaxResults?: number | undefined;
  NextToken?: string | undefined;
  DryRun?: boolean | undefined;
}
export interface VpnConnectionDeviceType {
  VpnConnectionDeviceTypeId?: string | undefined;
  Vendor?: string | undefined;
  Platform?: string | undefined;
  Software?: string | undefined;
}
export interface GetVpnConnectionDeviceTypesResult {
  VpnConnectionDeviceTypes?: VpnConnectionDeviceType[] | undefined;
  NextToken?: string | undefined;
}
export interface GetVpnTunnelReplacementStatusRequest {
  VpnConnectionId: string | undefined;
  VpnTunnelOutsideIpAddress: string | undefined;
  DryRun?: boolean | undefined;
}
export interface MaintenanceDetails {
  PendingMaintenance?: string | undefined;
  MaintenanceAutoAppliedAfter?: Date | undefined;
  LastMaintenanceApplied?: Date | undefined;
}
export interface GetVpnTunnelReplacementStatusResult {
  VpnConnectionId?: string | undefined;
  TransitGatewayId?: string | undefined;
  CustomerGatewayId?: string | undefined;
  VpnGatewayId?: string | undefined;
  VpnTunnelOutsideIpAddress?: string | undefined;
  MaintenanceDetails?: MaintenanceDetails | undefined;
}
export interface ImportClientVpnClientCertificateRevocationListRequest {
  ClientVpnEndpointId: string | undefined;
  CertificateRevocationList: string | undefined;
  DryRun?: boolean | undefined;
}
export interface ImportClientVpnClientCertificateRevocationListResult {
  Return?: boolean | undefined;
}
export interface ClientData {
  Comment?: string | undefined;
  UploadEnd?: Date | undefined;
  UploadSize?: number | undefined;
  UploadStart?: Date | undefined;
}
export interface UserBucket {
  S3Bucket?: string | undefined;
  S3Key?: string | undefined;
}
export interface ImageDiskContainer {
  Description?: string | undefined;
  DeviceName?: string | undefined;
  Format?: string | undefined;
  SnapshotId?: string | undefined;
  Url?: string | undefined;
  UserBucket?: UserBucket | undefined;
}
export interface ImportImageLicenseConfigurationRequest {
  LicenseConfigurationArn?: string | undefined;
}
export interface ImportImageRequest {
  Architecture?: string | undefined;
  ClientData?: ClientData | undefined;
  ClientToken?: string | undefined;
  Description?: string | undefined;
  DiskContainers?: ImageDiskContainer[] | undefined;
  DryRun?: boolean | undefined;
  Encrypted?: boolean | undefined;
  Hypervisor?: string | undefined;
  KmsKeyId?: string | undefined;
  LicenseType?: string | undefined;
  Platform?: string | undefined;
  RoleName?: string | undefined;
  LicenseSpecifications?: ImportImageLicenseConfigurationRequest[] | undefined;
  TagSpecifications?: TagSpecification[] | undefined;
  UsageOperation?: string | undefined;
  BootMode?: BootModeValues | undefined;
}
export interface ImportImageResult {
  Architecture?: string | undefined;
  Description?: string | undefined;
  Encrypted?: boolean | undefined;
  Hypervisor?: string | undefined;
  ImageId?: string | undefined;
  ImportTaskId?: string | undefined;
  KmsKeyId?: string | undefined;
  LicenseType?: string | undefined;
  Platform?: string | undefined;
  Progress?: string | undefined;
  SnapshotDetails?: SnapshotDetail[] | undefined;
  Status?: string | undefined;
  StatusMessage?: string | undefined;
  LicenseSpecifications?: ImportImageLicenseConfigurationResponse[] | undefined;
  Tags?: Tag[] | undefined;
  UsageOperation?: string | undefined;
}
export interface DiskImageDetail {
  Format: DiskImageFormat | undefined;
  Bytes: number | undefined;
  ImportManifestUrl: string | undefined;
}
export interface VolumeDetail {
  Size: number | undefined;
}
export interface DiskImage {
  Description?: string | undefined;
  Image?: DiskImageDetail | undefined;
  Volume?: VolumeDetail | undefined;
}
export interface UserData {
  Data?: string | undefined;
}
export interface ImportInstanceLaunchSpecification {
  Architecture?: ArchitectureValues | undefined;
  GroupNames?: string[] | undefined;
  GroupIds?: string[] | undefined;
  AdditionalInfo?: string | undefined;
  UserData?: UserData | undefined;
  InstanceType?: _InstanceType | undefined;
  Placement?: Placement | undefined;
  Monitoring?: boolean | undefined;
  SubnetId?: string | undefined;
  InstanceInitiatedShutdownBehavior?: ShutdownBehavior | undefined;
  PrivateIpAddress?: string | undefined;
}
export interface ImportInstanceRequest {
  DryRun?: boolean | undefined;
  Description?: string | undefined;
  LaunchSpecification?: ImportInstanceLaunchSpecification | undefined;
  DiskImages?: DiskImage[] | undefined;
  Platform: PlatformValues | undefined;
}
export interface ImportInstanceResult {
  ConversionTask?: ConversionTask | undefined;
}
export interface ImportKeyPairRequest {
  TagSpecifications?: TagSpecification[] | undefined;
  DryRun?: boolean | undefined;
  KeyName: string | undefined;
  PublicKeyMaterial: Uint8Array | undefined;
}
export interface ImportKeyPairResult {
  KeyFingerprint?: string | undefined;
  KeyName?: string | undefined;
  KeyPairId?: string | undefined;
  Tags?: Tag[] | undefined;
}
export interface SnapshotDiskContainer {
  Description?: string | undefined;
  Format?: string | undefined;
  Url?: string | undefined;
  UserBucket?: UserBucket | undefined;
}
export interface ImportSnapshotRequest {
  ClientData?: ClientData | undefined;
  ClientToken?: string | undefined;
  Description?: string | undefined;
  DiskContainer?: SnapshotDiskContainer | undefined;
  DryRun?: boolean | undefined;
  Encrypted?: boolean | undefined;
  KmsKeyId?: string | undefined;
  RoleName?: string | undefined;
  TagSpecifications?: TagSpecification[] | undefined;
}
export interface ImportSnapshotResult {
  Description?: string | undefined;
  ImportTaskId?: string | undefined;
  SnapshotTaskDetail?: SnapshotTaskDetail | undefined;
  Tags?: Tag[] | undefined;
}
export interface ImportVolumeRequest {
  DryRun?: boolean | undefined;
  AvailabilityZone: string | undefined;
  Image: DiskImageDetail | undefined;
  Description?: string | undefined;
  Volume: VolumeDetail | undefined;
}
export interface ImportVolumeResult {
  ConversionTask?: ConversionTask | undefined;
}
export interface ListImagesInRecycleBinRequest {
  ImageIds?: string[] | undefined;
  NextToken?: string | undefined;
  MaxResults?: number | undefined;
  DryRun?: boolean | undefined;
}
export interface ImageRecycleBinInfo {
  ImageId?: string | undefined;
  Name?: string | undefined;
  Description?: string | undefined;
  RecycleBinEnterTime?: Date | undefined;
  RecycleBinExitTime?: Date | undefined;
}
export interface ListImagesInRecycleBinResult {
  Images?: ImageRecycleBinInfo[] | undefined;
  NextToken?: string | undefined;
}
export interface ListSnapshotsInRecycleBinRequest {
  MaxResults?: number | undefined;
  NextToken?: string | undefined;
  SnapshotIds?: string[] | undefined;
  DryRun?: boolean | undefined;
}
export interface SnapshotRecycleBinInfo {
  SnapshotId?: string | undefined;
  RecycleBinEnterTime?: Date | undefined;
  RecycleBinExitTime?: Date | undefined;
  Description?: string | undefined;
  VolumeId?: string | undefined;
}
export interface ListSnapshotsInRecycleBinResult {
  Snapshots?: SnapshotRecycleBinInfo[] | undefined;
  NextToken?: string | undefined;
}
export declare const LockMode: {
  readonly compliance: "compliance";
  readonly governance: "governance";
};
export type LockMode = (typeof LockMode)[keyof typeof LockMode];
export interface LockSnapshotRequest {
  SnapshotId: string | undefined;
  DryRun?: boolean | undefined;
  LockMode: LockMode | undefined;
  CoolOffPeriod?: number | undefined;
  LockDuration?: number | undefined;
  ExpirationDate?: Date | undefined;
}
export interface LockSnapshotResult {
  SnapshotId?: string | undefined;
  LockState?: LockState | undefined;
  LockDuration?: number | undefined;
  CoolOffPeriod?: number | undefined;
  CoolOffPeriodExpiresOn?: Date | undefined;
  LockCreatedOn?: Date | undefined;
  LockExpiresOn?: Date | undefined;
  LockDurationStartTime?: Date | undefined;
}
export interface ModifyAddressAttributeRequest {
  AllocationId: string | undefined;
  DomainName?: string | undefined;
  DryRun?: boolean | undefined;
}
export interface ModifyAddressAttributeResult {
  Address?: AddressAttribute | undefined;
}
export declare const ModifyAvailabilityZoneOptInStatus: {
  readonly not_opted_in: "not-opted-in";
  readonly opted_in: "opted-in";
};
export type ModifyAvailabilityZoneOptInStatus =
  (typeof ModifyAvailabilityZoneOptInStatus)[keyof typeof ModifyAvailabilityZoneOptInStatus];
export interface ModifyAvailabilityZoneGroupRequest {
  GroupName: string | undefined;
  OptInStatus: ModifyAvailabilityZoneOptInStatus | undefined;
  DryRun?: boolean | undefined;
}
export interface ModifyAvailabilityZoneGroupResult {
  Return?: boolean | undefined;
}
export interface ModifyCapacityReservationRequest {
  CapacityReservationId: string | undefined;
  InstanceCount?: number | undefined;
  EndDate?: Date | undefined;
  EndDateType?: EndDateType | undefined;
  Accept?: boolean | undefined;
  DryRun?: boolean | undefined;
  AdditionalInfo?: string | undefined;
  InstanceMatchCriteria?: InstanceMatchCriteria | undefined;
}
export interface ModifyCapacityReservationResult {
  Return?: boolean | undefined;
}
export interface ModifyCapacityReservationFleetRequest {
  CapacityReservationFleetId: string | undefined;
  TotalTargetCapacity?: number | undefined;
  EndDate?: Date | undefined;
  DryRun?: boolean | undefined;
  RemoveEndDate?: boolean | undefined;
}
export interface ModifyCapacityReservationFleetResult {
  Return?: boolean | undefined;
}
export interface DnsServersOptionsModifyStructure {
  CustomDnsServers?: string[] | undefined;
  Enabled?: boolean | undefined;
}
export interface ModifyClientVpnEndpointRequest {
  ClientVpnEndpointId: string | undefined;
  ServerCertificateArn?: string | undefined;
  ConnectionLogOptions?: ConnectionLogOptions | undefined;
  DnsServers?: DnsServersOptionsModifyStructure | undefined;
  VpnPort?: number | undefined;
  Description?: string | undefined;
  SplitTunnel?: boolean | undefined;
  DryRun?: boolean | undefined;
  SecurityGroupIds?: string[] | undefined;
  VpcId?: string | undefined;
  SelfServicePortal?: SelfServicePortal | undefined;
  ClientConnectOptions?: ClientConnectOptions | undefined;
  SessionTimeoutHours?: number | undefined;
  ClientLoginBannerOptions?: ClientLoginBannerOptions | undefined;
}
export interface ModifyClientVpnEndpointResult {
  Return?: boolean | undefined;
}
export interface ModifyDefaultCreditSpecificationRequest {
  DryRun?: boolean | undefined;
  InstanceFamily: UnlimitedSupportedInstanceFamily | undefined;
  CpuCredits: string | undefined;
}
export interface ModifyDefaultCreditSpecificationResult {
  InstanceFamilyCreditSpecification?:
    | InstanceFamilyCreditSpecification
    | undefined;
}
export interface ModifyEbsDefaultKmsKeyIdRequest {
  KmsKeyId: string | undefined;
  DryRun?: boolean | undefined;
}
export interface ModifyEbsDefaultKmsKeyIdResult {
  KmsKeyId?: string | undefined;
}
export interface ModifyFleetRequest {
  DryRun?: boolean | undefined;
  ExcessCapacityTerminationPolicy?:
    | FleetExcessCapacityTerminationPolicy
    | undefined;
  LaunchTemplateConfigs?: FleetLaunchTemplateConfigRequest[] | undefined;
  FleetId: string | undefined;
  TargetCapacitySpecification?: TargetCapacitySpecificationRequest | undefined;
  Context?: string | undefined;
}
export interface ModifyFleetResult {
  Return?: boolean | undefined;
}
export interface LoadPermissionRequest {
  Group?: PermissionGroup | undefined;
  UserId?: string | undefined;
}
export interface LoadPermissionModifications {
  Add?: LoadPermissionRequest[] | undefined;
  Remove?: LoadPermissionRequest[] | undefined;
}
export declare const OperationType: {
  readonly add: "add";
  readonly remove: "remove";
};
export type OperationType = (typeof OperationType)[keyof typeof OperationType];
export interface ModifyFpgaImageAttributeRequest {
  DryRun?: boolean | undefined;
  FpgaImageId: string | undefined;
  Attribute?: FpgaImageAttributeName | undefined;
  OperationType?: OperationType | undefined;
  UserIds?: string[] | undefined;
  UserGroups?: string[] | undefined;
  ProductCodes?: string[] | undefined;
  LoadPermission?: LoadPermissionModifications | undefined;
  Description?: string | undefined;
  Name?: string | undefined;
}
export interface ModifyFpgaImageAttributeResult {
  FpgaImageAttribute?: FpgaImageAttribute | undefined;
}
export interface ModifyHostsRequest {
  HostRecovery?: HostRecovery | undefined;
  InstanceType?: string | undefined;
  InstanceFamily?: string | undefined;
  HostMaintenance?: HostMaintenance | undefined;
  HostIds: string[] | undefined;
  AutoPlacement?: AutoPlacement | undefined;
}
export interface ModifyHostsResult {
  Successful?: string[] | undefined;
  Unsuccessful?: UnsuccessfulItem[] | undefined;
}
export interface ModifyIdentityIdFormatRequest {
  Resource: string | undefined;
  UseLongIds: boolean | undefined;
  PrincipalArn: string | undefined;
}
export interface ModifyIdFormatRequest {
  Resource: string | undefined;
  UseLongIds: boolean | undefined;
}
export interface LaunchPermissionModifications {
  Add?: LaunchPermission[] | undefined;
  Remove?: LaunchPermission[] | undefined;
}
export interface ModifyImageAttributeRequest {
  Attribute?: string | undefined;
  Description?: AttributeValue | undefined;
  ImageId: string | undefined;
  LaunchPermission?: LaunchPermissionModifications | undefined;
  OperationType?: OperationType | undefined;
  ProductCodes?: string[] | undefined;
  UserGroups?: string[] | undefined;
  UserIds?: string[] | undefined;
  Value?: string | undefined;
  OrganizationArns?: string[] | undefined;
  OrganizationalUnitArns?: string[] | undefined;
  ImdsSupport?: AttributeValue | undefined;
  DryRun?: boolean | undefined;
}
export interface EbsInstanceBlockDeviceSpecification {
  VolumeId?: string | undefined;
  DeleteOnTermination?: boolean | undefined;
}
export interface InstanceBlockDeviceMappingSpecification {
  DeviceName?: string | undefined;
  Ebs?: EbsInstanceBlockDeviceSpecification | undefined;
  VirtualName?: string | undefined;
  NoDevice?: string | undefined;
}
export interface BlobAttributeValue {
  Value?: Uint8Array | undefined;
}
export interface ModifyInstanceAttributeRequest {
  SourceDestCheck?: AttributeBooleanValue | undefined;
  DisableApiStop?: AttributeBooleanValue | undefined;
  DryRun?: boolean | undefined;
  InstanceId: string | undefined;
  Attribute?: InstanceAttributeName | undefined;
  Value?: string | undefined;
  BlockDeviceMappings?: InstanceBlockDeviceMappingSpecification[] | undefined;
  DisableApiTermination?: AttributeBooleanValue | undefined;
  InstanceType?: AttributeValue | undefined;
  Kernel?: AttributeValue | undefined;
  Ramdisk?: AttributeValue | undefined;
  UserData?: BlobAttributeValue | undefined;
  InstanceInitiatedShutdownBehavior?: AttributeValue | undefined;
  Groups?: string[] | undefined;
  EbsOptimized?: AttributeBooleanValue | undefined;
  SriovNetSupport?: AttributeValue | undefined;
  EnaSupport?: AttributeBooleanValue | undefined;
}
export interface CapacityReservationSpecification {
  CapacityReservationPreference?: CapacityReservationPreference | undefined;
  CapacityReservationTarget?: CapacityReservationTarget | undefined;
}
export interface ModifyInstanceCapacityReservationAttributesRequest {
  InstanceId: string | undefined;
  CapacityReservationSpecification:
    | CapacityReservationSpecification
    | undefined;
  DryRun?: boolean | undefined;
}
export interface ModifyInstanceCapacityReservationAttributesResult {
  Return?: boolean | undefined;
}
export interface ModifyInstanceCpuOptionsRequest {
  InstanceId: string | undefined;
  CoreCount: number | undefined;
  ThreadsPerCore: number | undefined;
  DryRun?: boolean | undefined;
}
export interface ModifyInstanceCpuOptionsResult {
  InstanceId?: string | undefined;
  CoreCount?: number | undefined;
  ThreadsPerCore?: number | undefined;
}
export interface InstanceCreditSpecificationRequest {
  InstanceId: string | undefined;
  CpuCredits?: string | undefined;
}
export interface ModifyInstanceCreditSpecificationRequest {
  DryRun?: boolean | undefined;
  ClientToken?: string | undefined;
  InstanceCreditSpecifications:
    | InstanceCreditSpecificationRequest[]
    | undefined;
}
export interface SuccessfulInstanceCreditSpecificationItem {
  InstanceId?: string | undefined;
}
export declare const UnsuccessfulInstanceCreditSpecificationErrorCode: {
  readonly INCORRECT_INSTANCE_STATE: "IncorrectInstanceState";
  readonly INSTANCE_CREDIT_SPECIFICATION_NOT_SUPPORTED: "InstanceCreditSpecification.NotSupported";
  readonly INSTANCE_NOT_FOUND: "InvalidInstanceID.NotFound";
  readonly INVALID_INSTANCE_ID: "InvalidInstanceID.Malformed";
};
export type UnsuccessfulInstanceCreditSpecificationErrorCode =
  (typeof UnsuccessfulInstanceCreditSpecificationErrorCode)[keyof typeof UnsuccessfulInstanceCreditSpecificationErrorCode];
export interface UnsuccessfulInstanceCreditSpecificationItemError {
  Code?: UnsuccessfulInstanceCreditSpecificationErrorCode | undefined;
  Message?: string | undefined;
}
export interface UnsuccessfulInstanceCreditSpecificationItem {
  InstanceId?: string | undefined;
  Error?: UnsuccessfulInstanceCreditSpecificationItemError | undefined;
}
export interface ModifyInstanceCreditSpecificationResult {
  SuccessfulInstanceCreditSpecifications?:
    | SuccessfulInstanceCreditSpecificationItem[]
    | undefined;
  UnsuccessfulInstanceCreditSpecifications?:
    | UnsuccessfulInstanceCreditSpecificationItem[]
    | undefined;
}
export interface ModifyInstanceEventStartTimeRequest {
  DryRun?: boolean | undefined;
  InstanceId: string | undefined;
  InstanceEventId: string | undefined;
  NotBefore: Date | undefined;
}
export interface ModifyInstanceEventStartTimeResult {
  Event?: InstanceStatusEvent | undefined;
}
export declare const VerifiedAccessInstanceUserTrustProviderClientConfigurationFilterSensitiveLog: (
  obj: VerifiedAccessInstanceUserTrustProviderClientConfiguration
) => any;
export declare const ExportVerifiedAccessInstanceClientConfigurationResultFilterSensitiveLog: (
  obj: ExportVerifiedAccessInstanceClientConfigurationResult
) => any;
export declare const GetInstanceTpmEkPubResultFilterSensitiveLog: (
  obj: GetInstanceTpmEkPubResult
) => any;
export declare const GetLaunchTemplateDataResultFilterSensitiveLog: (
  obj: GetLaunchTemplateDataResult
) => any;
export declare const GetPasswordDataResultFilterSensitiveLog: (
  obj: GetPasswordDataResult
) => any;
export declare const GetVpnConnectionDeviceSampleConfigurationResultFilterSensitiveLog: (
  obj: GetVpnConnectionDeviceSampleConfigurationResult
) => any;
export declare const ImageDiskContainerFilterSensitiveLog: (
  obj: ImageDiskContainer
) => any;
export declare const ImportImageRequestFilterSensitiveLog: (
  obj: ImportImageRequest
) => any;
export declare const ImportImageResultFilterSensitiveLog: (
  obj: ImportImageResult
) => any;
export declare const DiskImageDetailFilterSensitiveLog: (
  obj: DiskImageDetail
) => any;
export declare const DiskImageFilterSensitiveLog: (obj: DiskImage) => any;
export declare const UserDataFilterSensitiveLog: (obj: UserData) => any;
export declare const ImportInstanceLaunchSpecificationFilterSensitiveLog: (
  obj: ImportInstanceLaunchSpecification
) => any;
export declare const ImportInstanceRequestFilterSensitiveLog: (
  obj: ImportInstanceRequest
) => any;
export declare const ImportInstanceResultFilterSensitiveLog: (
  obj: ImportInstanceResult
) => any;
export declare const SnapshotDiskContainerFilterSensitiveLog: (
  obj: SnapshotDiskContainer
) => any;
export declare const ImportSnapshotRequestFilterSensitiveLog: (
  obj: ImportSnapshotRequest
) => any;
export declare const ImportSnapshotResultFilterSensitiveLog: (
  obj: ImportSnapshotResult
) => any;
export declare const ImportVolumeRequestFilterSensitiveLog: (
  obj: ImportVolumeRequest
) => any;
export declare const ImportVolumeResultFilterSensitiveLog: (
  obj: ImportVolumeResult
) => any;
